/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "bitmap.h"

Bitmap::Bitmap()
{
	image = NULL;
}
		
Bitmap::Bitmap(char *filename)
{
	image = NULL;
	load_from_file(filename);
}
		
Bitmap::~Bitmap()
{
	if (image!=NULL) {SDL_FreeSurface(image);	}
}
		
void Bitmap::load_from_file(char *filename)
{
	if (image!=NULL) { SDL_FreeSurface(image); }
	
	image = SDL_LoadBMP(filename);
	if (image == NULL)
	{
		fprintf(stderr, "Couldn't load imgae %s\n", SDL_GetError());
		return;
	}
	SDL_SetColorKey(image,SDL_SRCCOLORKEY,SDL_MapRGB(image->format,255,0,255));	
}
		
void Bitmap::draw(SDL_Surface *screen, int x, int y)
{
	SDL_Rect destRect = {x, y, image->w, image->h};
	if(SDL_BlitSurface(image, NULL, screen, &destRect) < 0)
	{
		fprintf(stderr, "BlitSurface error: %s\n", SDL_GetError());
	}
}
		
int Bitmap::w()
{
	int _w = 0;
	if (image>=NULL) _w = image->w;
	return _w;		
}

int Bitmap::h()
{
	int _h = 0;
	if (image>=NULL) _h = image->h;
	return _h;
}

