/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef _SHARED_H_
#define _SHARED_H_

#include "engine.h"
#include "bitmap.h"
#include "bitmapfont.h"
#include "text.h"
#include "options.h"
#include "history.h"
#include "plaintextrenderer.h"



class shared
{
	public:
	
		static const int SCREEN_W = 320;
		static const int SCREEN_H = 240;
	
		static const int TEXT_W = 320;
	
		static SDL_Joystick *joystick;
		static SDL_Surface *screen;

		static BitmapFont *text_font;
	
		static AppEngine *app;
	
		static PlainTextRenderer *plain_text_renderer;
	
		static Text *text;
	
		static Options *options;
		
		static History *history;
		
		static Bitmap *background_image;
				
};

#endif
