/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "state_choosefont.h"
#include "defines.h"
#include "bitmap.h"
#include "SDL/SDL.h"
#include "string.h"
#include "shared.h"
#include "util.h"
#include "gui.h"
#include "gui_skin.h"
#include "widget_font.h"
#include "widget_file.h"
#include <dirent.h>
#include <string>

// AppState //////////////////////////////////////////////////////////////////////////////////

ChooseFontState::~ChooseFontState()
{
	delete [] status_text;
}

void ChooseFontState::on_init()
{
	status_text = util::utf8_to_unicode("èSeleccionar  ìCancelar");
	gui = new Gui(10,80,300,130);
	rescan();
};
		
void ChooseFontState::on_button_down(int button)
{
	gui->on_button_down(button);
	redraw();
	
	if (button==GP2X_BUTTON_X)
	{
		// cancel
		app->change_to_state(ST_PREFERENCES);
	}
	else if (button==GP2X_BUTTON_A)
	{
		// preview
		redraw();		
	}
	else if (button==GP2X_BUTTON_B)
	{
		shared::options->set_font(((FontWidget *)gui->get_selected_widget())->get_name());

		// load selected font
		std::string s = ("fonts/"+shared::options->get_font()) + ".bmp";
		shared::text_font->load(s,CHAR_LIST);

		app->change_to_state(ST_PREFERENCES);		
	}
};

void ChooseFontState::on_button_up(int button)
{
};
	
void ChooseFontState::think(bool first)
{
	if (first)
	{	
		redraw();
	}
}

void ChooseFontState::redraw()
{
	shared::background_image->draw(shared::screen,0,0);

	gui->draw(shared::screen);
	GuiSkin::get_small_font()->draw_unicode(status_text,shared::screen,160,228,true);
		
	SDL_Flip(shared::screen);
};

void ChooseFontState::rescan()
{
	gui->clear();
	
	struct dirent *dit;
	DIR *dirp;
	
	if ((dirp=opendir("fonts")) != NULL)
	{
		while ((dit = readdir(dirp)) != NULL)
		{
			if (dit->d_type!=DT_DIR)
			{
				std::string name = std::string(dit->d_name);
				name = name.substr(0,name.length()-4);
				gui->add_widget(new FontWidget(name.c_str()));
			}
		}
	}
}
