/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "state_loading.h"
#include "defines.h"
#include "bitmap.h"
#include "SDL/SDL.h"
#include "shared.h"
#include "util.h"
#include "gui.h"
#include "gui_skin.h"

LoadingState::~LoadingState()
{
}

void LoadingState::on_init()
{
	text = util::utf8_to_unicode("Abriendo archivo. Espere un momento.");
};
		
void LoadingState::on_button_down(int button)
{
};

void LoadingState::on_button_up(int button)
{
};
	
void LoadingState::think(bool first)
{
	if (first)
	{	
		util::hw_set_cpu(HIGH_SPEED);

		redraw();
		// load font
		std::string s = ("fonts/"+shared::options->get_font())+".bmp";
		shared::text_font->load(s,CHAR_LIST);

		// load text
		shared::text->load();

		// looks on history
		for (int i=0; i<shared::history->get_item_count(); i++)
		{
			if (shared::history->get_item_filename(i)==shared::text->get_filename_string())
			{
				shared::text->go_to_percent(shared::history->get_item_percent(i));
			}
		}
		
		util::hw_set_cpu(LOW_SPEED);

		app->change_to_state(ST_READER);
	}
}

void LoadingState::redraw()
{
	shared::background_image->draw(shared::screen,0,0);

	GuiSkin::get_small_font()->draw_unicode(text,shared::screen, 160, 140, true, true);
		
	SDL_Flip(shared::screen);
};
