/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "state_preferences.h"
#include "defines.h"
#include "bitmap.h"
#include "SDL/SDL.h"
#include "shared.h"
#include "util.h"
#include "gui.h"
#include "gui_skin.h"
#include "widget_text.h"
#include "widget_separator.h"
#include "widget_basic.h"
#include "widget_checkbox.h"
#include "widget_slider.h"


PreferencesState::~PreferencesState()
{
}

void PreferencesState::on_init()
{
	text_changed = util::utf8_to_unicode("ëGuardar ïVolver al menú");
	text_unchanged = util::utf8_to_unicode("ïVolver al menú");

	gui = new Gui(10,50,300,170);
	
	gui->add_widget(new TextWidget("Opciones", false, true));
	gui->add_widget(new SeparatorWidget(10));

	widget_justify = new CheckBoxWidget(util::utf8_to_unicode("Justificado"));
	gui->add_widget(widget_justify);
	
	widget_indent = new CheckBoxWidget(util::utf8_to_unicode("Sangría"));
	gui->add_widget(widget_indent);

	widget_showstatus = new CheckBoxWidget(util::utf8_to_unicode("Mostrar barra de estado"));
	gui->add_widget(widget_showstatus);

	widget_margin = new SliderWidget("Margen",0,20);
	gui->add_widget(widget_margin);

	widget_font = new BasicWidget();
	widget_font->set_text1(util::utf8_to_unicode("Fuente: bookman12"),true);
	widget_font->set_text2(util::utf8_to_unicode("èCambiar"),true);	
	gui->add_widget(widget_font);

	load(); 


};
		
void PreferencesState::on_button_down(int button)
{
	
	if (button==GP2X_BUTTON_START)
	{
		ok(false);
		app->change_to_state(ST_MENU);
	}
	else if (button==GP2X_BUTTON_SELECT)
	{
		ok(true);
		redraw();
	}
	else
	{
		gui->on_button_down(button);
		
		if (button==GP2X_BUTTON_B && gui->get_selected_widget()==widget_font)
		{
			app->change_to_state(ST_CHOOSEFONT);
		}
		// apply changes
		ok(false);
		
		redraw();
	}
};

void PreferencesState::on_button_up(int button)
{
};
	
void PreferencesState::think(bool first)
{
	if (first)
	{	
		load();
		redraw();
	}
}

void PreferencesState::redraw()
{
	shared::background_image->draw(shared::screen,0,0);
	gui->draw(shared::screen);

	GuiSkin::get_small_font()->draw_unicode(shared::options->has_changed()?text_changed:text_unchanged,shared::screen,160,228,true);

		
	SDL_Flip(shared::screen);
};

void PreferencesState::ok(bool save)
{
	shared::options->set_justify(widget_justify->is_checked());
	shared::options->set_indent(widget_indent->is_checked());
	shared::options->set_margin(widget_margin->get_value());
	shared::options->set_showstatus(widget_showstatus->is_checked());

	if (save) shared::options->save();	
}

void PreferencesState::load()
{
	widget_justify->set_checked(shared::options->get_justify());
	widget_indent->set_checked(shared::options->get_indent());
	widget_margin->set_value(shared::options->get_margin());
	widget_showstatus->set_checked(shared::options->get_showstatus());

	std::string s = "Fuente: " + shared::options->get_font();
	widget_font->set_text1(util::utf8_to_unicode(s.c_str()),true);
}
