/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "defines.h"
#include "gui_skin.h"
#include "widget_basic.h"
#include "bitmapfont.h"
#include "util.h"
#include <vector>

BasicWidget::BasicWidget()
{
	text1 = NULL;
	text2 = NULL;
	icon = NULL;
	selectable = true;
}

BasicWidget::~BasicWidget()
{
	if (text1!=NULL && delete_text1) 
	{
///		delete text1;
	}
	if (text2!=NULL && delete_text2) 
	{
///		delete text2;
	}
	if (icon!=NULL && delete_icon) 
	{
		delete icon;
	}	
}

// inherited
int BasicWidget::draw(SDL_Surface *dest, int x, int y, int w, bool selected)
{
	// first draws frame if needed -----------------------------------------
	if (selected)
	{
		GuiSkin::draw_selection(dest,x,y,w, this->get_height(selected));
	}

	// then draws content  -------------------------------------------------
	int current_y = y+1; // top margin
	
	int text_x = x + (icon==NULL ? 4 : icon->w()+6);
		
	// icon and text1
	if (icon!=NULL) icon->draw(dest,x+4, current_y);
	if (text1!=NULL) GuiSkin::get_big_font()->draw_unicode(text1,dest,text_x,current_y);	
	
	if (icon!=NULL || text1!=NULL) current_y += GuiSkin::get_big_font()->get_height();
		
	// extra content
	draw_custom_content(dest,x,current_y,w,selected);
	current_y += get_custom_content_height(selected);
	
	// text2
	if (text2!=NULL && selected) GuiSkin::get_small_font()->draw_unicode(text2,dest,x+4,current_y);
	

	return this->get_height(selected);
}

int BasicWidget::get_height(bool selected)
{
	int total_h = 2; // top + bottom margin

	if (text1!=NULL) total_h += GuiSkin::get_big_font()->get_height();
	
	total_h += get_custom_content_height(selected);

	if (selected && text2!=NULL) total_h += GuiSkin::get_small_font()->get_height();
	
	return total_h;
}

		
bool BasicWidget::is_selectable()
{
	return selectable;
}
