/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef SLIDERWIDGET_H
#define SLIDERWIDGET_H

#include "SDL/SDL.h"
#include "widget_basic.h"
#include "bitmap.h"
#include "bitmapfont.h"
#include <vector>


class SliderWidget : public BasicWidget
{
	public:

		SliderWidget(const std::string &text, int min, int max);
		~SliderWidget();

		bool on_button_down(int button);
		bool on_button_up(int button) { return false; };
		
		
		void set_value(int v);
		inline void inc_value(int i) { set_value(get_value()+i); }
		inline int get_value() { return value; }
		
	
	private:
		int min;
		int max;
		int value;
		
		std::string text;
		char final_text[64];
};


#endif
