/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "widget_text.h"
#include "bitmapfont.h"
#include "util.h"
#include "gui_skin.h"

TextWidget::TextWidget(char *t, bool s, bool center)
{
	text = util::utf8_to_unicode(t);
	selectable = s;
	centered = center;
}

TextWidget::~TextWidget()
{
	delete []text;
}

// inherited
int TextWidget::draw(SDL_Surface *dest, int x, int y, int w, bool selected)
{
	if (selected)
	{
		//draw_highlight(dest,x,y,w, this->get_height(selected));
		GuiSkin::draw_selection(dest,x,y,w, this->get_height(selected));
	}

	if (centered) GuiSkin::get_big_font()->draw_unicode(text,dest,x+w>>1,y+1,true);
	else GuiSkin::get_big_font()->draw_unicode(text,dest,x+4,y+1);

	return this->get_height(selected);
}

int TextWidget::get_height(bool selected)
{
	return GuiSkin::get_big_font()->get_height()+2;
}

bool TextWidget::on_button_down(int button)
{
	return false;
}

bool TextWidget::on_button_up(int button)
{
	return false;
}
		
bool TextWidget::is_selectable()
{
	return selectable;
}

